# DocumenterTools

| **Documentation**                       | **Build Status**                |
|:---------------------------------------:|:-------------------------------:|
| [![][docs-stable-img]][docs-stable-url] | [![][GHA-img]][GHA-url] [![][codecov-img]][codecov-url] [![PkgEval][pkgeval-img]][pkgeval-url] |

This package contains utilities for setting up documentation generation with
[Documenter.jl][documenter].

## Installation

The package can be added using the Julia package manager. From the Julia REPL, type `]` to
enter the Pkg REPL mode and run

```
pkg> add DocumenterTools
```

[documenter]: https://github.com/JuliaDocs/Documenter.jl

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://documenter.juliadocs.org/stable/lib/internals/documentertools/

[codecov-img]: https://codecov.io/gh/JuliaDocs/DocumenterTools.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaDocs/DocumenterTools.jl

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/D/DocumenterTools.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/D/DocumenterTools.html

[GHA-img]: https://github.com/JuliaDocs/DocumenterTools.jl/actions/workflows/CI.yml/badge.svg
[GHA-url]: https://github.com/JuliaDocs/DocumenterTools.jl/actions/workflows/CI.yml

using Test
using DocumenterTools
import Documenter

@testset "DocumenterTools" begin
    @testset "generate" begin
        include("generate.jl")
    end

    @testset "genkeys-added" begin
        using Example
        @test_logs (:info, r"Add the key below") (:info, r"Add a secure 'Repository secret' named 'DOCUMENTER_KEY'") DocumenterTools.genkeys(user="JuliaLang", repo="git@github.com:JuliaLang/Example.jl.git", io=devnull)
    end

    @testset "genkeys-deved" begin
        import Pkg
        # It's unlikely that Revise will ever enter our dependency graph
        Pkg.develop("Revise")
        import Revise
        @test_logs (:info, r"Add the key below") (:info, r"Add a secure 'Repository secret' named 'DOCUMENTER_KEY'") DocumenterTools.genkeys(Revise; io=devnull)
    end

    @testset "outdated warnings" begin
        include("outdated.jl")
    end

    @test_logs (:info, r"SetupBuildDirectory") (:info, r"Doctest") (:info, r"Skipped ExpandTemplates step") (:info, r"Skipped CrossReferences step") (:info, r"Skipped CheckDocument step") (:info, r"Skipped Populate step") (:info, r"Skipped RenderDocument step") Documenter.doctest(nothing, [DocumenterTools])
end

module DocumenterTools

using DocStringExtensions

"""
    DocumenterTools.generate(path::String = "docs"; name = nothing, format = :html)

Create a documentation stub in `path`, which is usually a sub folder in
the package root. The name of the package is determined automatically,
but can be given with the `name` keyword argument.

`generate` can also be called without any arguments, in which case it simply puts all
the generated files into a `docs` directory in the current working directory. This
way, if you are already in the root directory of your package, you generally only need
to call `generate()` to generate the documentation stub.

`generate` creates the following files in `path`:

```
.gitignore
src/index.md
make.jl
mkdocs.yml
Project.toml
```

# Arguments

**`path`** file path to the documentation directory to be created (default is `"docs"`).

# Keywords Arguments

**`name`** is the name of the package (without `.jl`). If `name` is not given
`generate` tries to detect it automatically.

**`format`** can be either `:html` (default), `:markdown` or `:pdf` corresponding
to the `format` keyword to Documenter's `makedocs` function, see
[Documenter's manual](https://documenter.juliadocs.org/stable/man/other-formats/).

# Examples
```julia-repl
julia> using DocumenterTools

julia> DocumenterTools.generate("path/to/MyPackage/docs")
[ ... output ... ]
```
"""
function generate(path::AbstractString="docs"; name::Union{AbstractString,Nothing}=nothing,
                  format = :html)
    # TODO:
    #   - set up deployment to `gh-pages`
    #   - fetch url and username automatically (e.g from git remote.origin.url)

    if !(format in (:html, :markdown, :pdf))
        throw(ArgumentError("format `$(repr(format))` not supported."))
    end

    path = abspath(path)
    if isdir(path)
        throw(ArgumentError("directory `$(Base.contractuser(path))` already exists."))
    end

    # determine name of package unless it is given
    if name === nothing
        srcdir = normpath(joinpath(path, "..", "src"))
        candidates = String[]
        if isdir(srcdir)
            for file in readdir(srcdir)
                if isfile(joinpath(srcdir, file))
                    modulename = splitext(file)[1]
                    str = read(joinpath(srcdir, file), String)
                    i = findfirst(Regex("module\\s+" * modulename), str)
                    i !== nothing && push!(candidates, modulename)
                end
            end
        end
        if length(candidates) != 1 # || name === nothing
            throw(ArgumentError(string("could not determine name of package located ",
                "in `$(Base.contractuser(normpath(joinpath(path, ".."))))`. ",
                "Please specify the `name` keyword argument to `DocumenterTools.generate`.")))
        end
        name = candidates[1]
        @info("name of package automatically determined to be `$(name)`.")
    end
    @assert name !== nothing

    # deploy the stub
    try
        @info("deploying documentation to `$(Base.contractuser(path))`")
        mkdir(path)

        # create the root doc files
        Generator.savefile(path, ".gitignore") do io
            write(io, Generator.gitignore())
        end
        Generator.savefile(path, "make.jl") do io
            write(io, Generator.make(name; format = format))
        end
        if format === :markdown
            Generator.savefile(path, "mkdocs.yml") do io
                write(io, Generator.mkdocs(name))
            end
        end
        Generator.savefile(path, "Project.toml") do io
            write(io, Generator.project(; format = format))
        end

        # Create the default documentation source files
        Generator.savefile(path, "src/index.md") do io
            write(io, Generator.index(name))
        end
    catch
        rm(path, recursive=true)
        rethrow()
    end
    nothing
end

"""
    DocumenterTools.generate(pkg::Module; dir = "docs", format = :html)

Same as `generate(path::String)` but the `path` and name is determined
automatically from the module.

!!! note
    The package must be in development mode. Make sure you run
    `pkg> develop MyPackage` from the Pkg REPL, or `Pkg.develop(\"MyPackage\")`
    before generating docs.

# Examples
```julia-repl
julia> using DocumenterTools

julia> using MyPackage

julia> DocumenterTools.generate(MyPackage)
[ ... output ... ]
```
"""
function generate(pkg::Module; dir = "docs", format = :html)
    package_path = package_devpath(pkg)
    name = String(nameof(pkg))
    return generate(joinpath(package_path, dir); name = name, format = format)
end


"""
$(SIGNATURES)

Returns the path to the top level directory of a devved out package source tree. The package
is identified by its top level module `pkg`.
"""
function package_devpath(pkg::Module)
    pkg == parentmodule(pkg) || throw(ArgumentError("$(pkg) is a submodule. Use the package top-level module."))
    path = pathof(pkg)
    path === nothing && throw(ArgumentError("could not find path to $(pkg)."))
    name = String(nameof(pkg))

    # check that pkg is not originating from a standard installation directory
    # since those are supposed to be immutable.
    for depot in DEPOT_PATH
        sep = Sys.iswindows() ? "\\\\" : "/"
        if startswith(path, joinpath(depot, "packages", name)) &&
            occursin(Regex(name * sep * "\\w{4,5}" * sep * "src" * sep * name * ".jl"), path)
            throw(ArgumentError(string(
                "module $(name) was found in a standard installation directory. ",
                "Please make sure that $(name) is ready for development by running ",
                "`pkg> develop $(name)` from the Pkg REPL, or ",
                "`Pkg.develop(\"$(name)\")` from the Julia REPL, and try again.")))
        end
    end
    # We assume that the path to source file of pkg is ../Package/src/Package.jl, but we
    # return simply the top level directory of the package (i.e. ../Package)
    return normpath(joinpath(path, "..", ".."))
end

include("genkeys.jl")
include("Generator.jl")
include("Themes.jl")
include("OutdatedWarning.jl")

end # module

# Deprecated module
export Travis
module Travis
    import ..DocumenterTools
    export genkeys
    function genkeys(args...; kwargs...)
        Base.depwarn("Travis.genkeys is deprecated, use DocumenterTools.genkeys instead", :genkeys)
        return DocumenterTools.genkeys(args...; kwargs...)
    end
end # module

using Base64
import LibGit2: GITHUB_REGEX
using OpenSSH_jll: ssh_keygen
using Git: git

"""
    DocumenterTools.genkeys(; user="\$USER", repo="\$REPO")

Generates the SSH keys necessary for the automatic deployment of documentation with
Documenter from a builder to GitHub Pages.

By default the links in the instructions need to be modified to correspond to actual URLs.
The optional `user` and `repo` keyword arguments can be specified so that the URLs in the
printed instructions could be copied directly. They should be the name of the GitHub user or
organization where the repository is hosted and the full name of the repository,
respectively.

# Examples

```jldoctest; filter = [r"ssh-rsa [A-Za-z0-9+/=.]+", r"LS0t[A-Za-z0-9+/=.]+"]
julia> using DocumenterTools

julia> DocumenterTools.genkeys()
┌ Info: Add the key below as a new 'Deploy key' on GitHub (https://github.com/\$USER/\$REPO/settings/keys) with read and write access.
└ The 'Title' field can be left empty as GitHub can infer it from the key comment.

ssh-rsa AAAAB3NzaC2yc2EAAAaDAQABAAABAQDrNsUZYBWJtXYUk21wxZbX3KxcH8EqzR3ZdTna0Wgk...jNmUiGEMKrr0aqQMZEL2BG7 Documenter

[ Info: Add a secure 'Repository secret' named 'DOCUMENTER_KEY' (to https://github.com/\$USER/\$REPO/settings/secrets if you deploy using GitHub Actions) with value:

LS0tLS1CRUdJTiBSU0EgUFJJVkFURSBLRVktLS0tLQpNSUlFb3dJQkFBS0NBUUVBNnpiRkdXQVZpYlIy...QkVBRWFjY3BxaW9uNjFLaVdOcDU5T2YrUkdmCi0tLS0tRU5EIFJTQSBQUklWQVRFIEtFWS0tLS0tCg==


julia> DocumenterTools.genkeys(user="JuliaDocs", repo="DocumenterTools.jl")
┌ Info: Add the key below as a new 'Deploy key' on GitHub (https://github.com/JuliaDocs/DocumenterTools.jl/settings/keys) with read and write access.
└ The 'Title' field can be left empty as GitHub can infer it from the key comment.

ssh-rsa AAAAB3NzaC2yc2EAAAaDAQABAAABAQDrNsUZYBWJtXYUk21wxZbX3KxcH8EqzR3ZdTna0Wgk...jNmUiGEMKrr0aqQMZEL2BG7 Documenter

[ Info: Add a secure 'Repository secret' named 'DOCUMENTER_KEY' (to https://github.com/JuliaDocs/DocumenterTools.jl/settings/secrets if you deploy using GitHub Actions) with value:

LS0tLS1CRUdJTiBSU0EgUFJJVkFURSBLRVktLS0tLQpNSUlFb3dJQkFBS0NBUUVBNnpiRkdXQVZpYlIy...QkVBRWFjY3BxaW9uNjFLaVdOcDU5T2YrUkdmCi0tLS0tRU5EIFJTQSBQUklWQVRFIEtFWS0tLS0tCg==
```
"""
function genkeys(; user="\$USER", repo="\$REPO", io::IO=stdout)
    sshkeygen = ssh_keygen()

    filename  = "documenter-private-key"
    isfile(filename) && error("temporary file '$(filename)' already exists in working directory")
    isfile("$(filename).pub") && error("temporary file '$(filename).pub' already exists in working directory")

    # Generate the ssh key pair.
    mktempdir() do path
        cd(path) do
            cmd = `$(sshkeygen) -t rsa -N "" -C Documenter -m PEM -f $filename`
            out, err = IOBuffer(), IOBuffer()
            try
                run(pipeline(cmd, stdout=out, stderr=err))

                # Prompt user to add public key to github then remove the public key.
                let url = "https://github.com/$user/$repo/settings/keys"
                    @info """
                    Add the key below as a new 'Deploy key' on GitHub ($url) with read and write access.
                    The 'Title' field can be left empty as GitHub can infer it from the key comment.
                    """
                    println(io, "\n", read("$filename.pub", String))
                end

                # Base64 encode the private key and prompt user to add it to travis. The key is
                # *not* encoded for the sake of security, but instead to make it easier to
                # copy/paste it over to travis without having to worry about whitespace.
                let github_url = "https://github.com/$user/$repo/settings/secrets"
                    @info("Add a secure 'Repository secret' named 'DOCUMENTER_KEY' " *
                        "(to $(github_url) if you deploy using GitHub Actions) with value:")
                    println(io, "\n", base64encode(read(filename, String)), "\n")
                end
            catch e
                @error """
                Failed to generate a SSH key pair.
                > stdout from ssh-keygen:
                $(String(take!(out)))
                > stderr from ssh-keygen:
                $(String(take!(err)))
                """ isfile(filename) isfile("$(filename).pub") exception = (e, catch_backtrace())
                rethrow(e)
            finally
                # mktempdir() should clean up the the files, but just in case..
                rm(filename, force=true)
                rm("$(filename).pub", force=true)
            end
        end
    end
end

"""
    genkeys(package::Module; remote="origin")

Like the other method, this generates the SSH keys necessary for the automatic deployment of
documentation with Documenter from a builder to GitHub Pages, but attempts to guess the package
URLs from the Git remote.

`package` needs to be the top level module of the package. The `remote` keyword argument can
be used to specify which Git remote is used for guessing the repository's GitHub URL.

This method requires the following command lines programs to be installed:

- `which` (Unix) or `where` (Windows)
- `git`

!!! note
    The package must be in development mode. Make sure you run
    `pkg> develop pkg` from the Pkg REPL, or `Pkg.develop(\"pkg\")`
    before generating the SSH keys.

# Examples

```julia-repl
julia> using DocumenterTools

julia> DocumenterTools.genkeys(DocumenterTools)
[Info: add the public key below to https://github.com/JuliaDocs/DocumenterTools.jl/settings/keys with read/write access:

ssh-rsa AAAAB3NzaC2yc2EAAAaDAQABAAABAQDrNsUZYBWJtXYUk21wxZbX3KxcH8EqzR3ZdTna0Wgk...jNmUiGEMKrr0aqQMZEL2BG7 username@hostname

[ Info: add a secure 'Repository secret' named 'DOCUMENTER_KEY' to https://travis-ci.com/JuliaDocs/DocumenterTools.jl/settings (if you deploy using Travis CI) or https://github.com/JuliaDocs/DocumenterTools.jl/settings/secrets (if you deploy using GitHub Actions) with value:

LS0tLS1CRUdJTiBSU0EgUFJJVkFURSBLRVktLS0tLQpNSUlFb3dJQkFBS0NBUUVBNnpiRkdXQVZpYlIy...QkVBRWFjY3BxaW9uNjFLaVdOcDU5T2YrUkdmCi0tLS0tRU5EIFJTQSBQUklWQVRFIEtFWS0tLS0tCg==
```
"""
function genkeys(package::Module; remote="origin", io::IO=stdout)
    path = package_devpath(package)

    # Are we in a git repo?
    user, repo = cd(path) do
        success(`$(git()) status`) || error("Failed to run `git status` in $(path). 'DocumenterTools.genkeys' only works with Git repositories.")

        let r = readchomp(`$(git()) config --get remote.$remote.url`)
            m = match(GITHUB_REGEX, r)
            m === nothing && error("no remote repo named '$remote' found.")
            m[2], m[3]
        end
    end

    # Generate the ssh key pair.
    genkeys(; user=user, repo=repo, io=io)
end

export OutdatedWarning

module OutdatedWarning
using Gumbo, AbstractTrees, Documenter

OLD_VERSION_CSS = replace("""
.outdated-warning-overlay {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.3);
  z-index: 999;
  background-color: #ffaba7;
  color: rgba(0, 0, 0, 0.7);
  border-bottom: 3px solid #da0b00;
  padding: 10px 35px;
  text-align: center;
  font-size: 15px; }
  .outdated-warning-overlay .outdated-warning-closer {
    position: absolute;
    top: calc(50% - 10px);
    right: 18px;
    cursor: pointer;
    width: 12px; }
  .outdated-warning-overlay a {
    color: #2e63b8; }
    .outdated-warning-overlay a:hover {
      color: #363636; }
""", '\n' => "")

OUTDATED_VERSION_ATTR = isdefined(Documenter.Writers.HTMLWriter, :OUTDATED_VERSION_ATTR) ?
    Documenter.Writers.HTMLWriter.OUTDATED_VERSION_ATTR : "data-outdated-warner"

OLD_VERSION_WARNER = """
function maybeAddWarning () {
    const head = document.getElementsByTagName('head')[0];

    // Add a noindex meta tag (unless one exists) so that search engines don't index this version of the docs.
    if (document.body.querySelector('meta[name="robots"]') === null) {
        const meta = document.createElement('meta');
        meta.name = 'robots';
        meta.content = 'noindex';

        head.appendChild(meta);
    };

    // Add a stylesheet to avoid inline styling
    const style = document.createElement('style');
    style.type = 'text/css';
    style.appendChild(document.createTextNode('$(OLD_VERSION_CSS)'));
    head.appendChild(style);

    const div = document.createElement('div');
    div.classList.add('outdated-warning-overlay');
    const closer = document.createElement('div');
    closer.classList.add('outdated-warning-closer');

    // Icon by font-awesome (license: https://fontawesome.com/license, link: https://fontawesome.com/icons/times?style=solid)
    closer.innerHTML = '<svg aria-hidden="true" focusable="false" data-prefix="fas" data-icon="times" class="svg-inline--fa fa-times fa-w-11" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 352 512"><path fill="currentColor" d="M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"></path></svg>';
    closer.addEventListener('click', function () {
        document.body.removeChild(div);
    });
    let href = '/stable';
    if (window.documenterBaseURL) {
        href = window.documenterBaseURL + '/../stable';
    }
    div.innerHTML = 'This documentation is not for the latest version. <br> <a href="' + href + '">Go to the latest documentation</a>.';
    div.appendChild(closer);
    document.body.appendChild(div);
};

if (document.readyState === 'loading') {
    document.addEventListener('DOMContentLoaded', maybeAddWarning);
} else {
    maybeAddWarning();
};
"""

function add_old_docs_notice(index, force = false)
    html = read(index, String)
    parsed = Gumbo.parsehtml(html)

    did_update = false
    for el in PreOrderDFS(parsed.root)
        if el isa HTMLElement && Gumbo.tag(el) == :head
            old_notice = get_notice(el)

            if old_notice === nothing
                push!(el.children, make_notice(el))
                did_update = true
            elseif force
                update_notice(old_notice)
                did_update = true
            end

            break
        end
    end

    if did_update
        open(index, "w") do io
            print(io, parsed)
        end
    end
    return did_update
end

function make_notice(parent)
    script = Gumbo.HTMLElement{:script}([], parent, Dict(OUTDATED_VERSION_ATTR => ""))
    content = Gumbo.HTMLText(script, OLD_VERSION_WARNER)
    push!(script.children, content)
    return script
end

function update_notice(script)
    content = Gumbo.HTMLText(script, OLD_VERSION_WARNER)
    empty!(script.children)
    push!(script.children, content)
    return script
end

function get_notice(html)
    for el in PreOrderDFS(html)
        if el isa HTMLElement && Gumbo.tag(el) == :script
            attrs = Gumbo.attrs(el)
            if haskey(attrs, OUTDATED_VERSION_ATTR)
                return el
            end
        end
    end
    return nothing
end

"""
    generate([io::IO = stdout,] root::String;force = false)

This function adds a (unconditional) warning (and `noindex` meta tag) to all
versions of the documentation in `root`.

`force` overwrites a previous injected warning message created by this function.

A typical use case is to run this on the `gh-pages` branch of a package. Make sure
you review which changes you check in if you are *not* tagging a new release
of your package's documentation at the same time.
"""
function generate(root::String; kwargs...)
    @warn("""
    Adding an `OutdatedWarning` to all versions of the documentation in $(root).
    A typical use case is to run this on the `gh-pages` branch of a package. Make sure
    you review which changes you check in if you are *not* tagging a new release
    of your package's documentation at the same time. For example you should
    _not_ check in the folder `vX.Y.Z` corresponding to your latest release.
    """)
    return generate(stdout, root; kwargs...)
end
function generate(io::IO, root::String;force = false)
    for dir in readdir(root)
        path = joinpath(root, dir)
        islink(path) && continue
        isdir(path) || continue
        index = joinpath(path, "index.html")
        isfile(index) || continue

        if endswith(path, "dev")
            println(io, "Skipping $(dir) since it's a dev version.")
            continue
        end

        print(io, "Processing $(dir): ")
        for (root, _, files) in walkdir(path)
            for file in files
                _, ext = splitext(file)
                if ext == ".html"
                    try
                        did_change = add_old_docs_notice(joinpath(root, file), force)
                        print(io, did_change ? "✓" : ".")
                    catch err
                        if err isa InterruptException
                            rethrow()
                        end
                        @debug "Fatally failed to add a outdated warning" exception = (err, catch_backtrace())
                        print(io, "!")
                    end
                end
            end
        end
        println(io)
    end
end

end

"""
Provides the functions related to generating documentation stubs.
"""
module Generator

using DocStringExtensions

"""
$(SIGNATURES)

Attempts to save a file at `\$(root)/\$(filename)`. `f` will be called with file
stream (see [`open`](https://docs.julialang.org/en/v1/base/io-network/#Base.open)).

`filename` can also be a file in a subdirectory (e.g. `src/index.md`), and then
then subdirectories will be created automatically.
"""
function savefile(f, root, filename)
    filepath = joinpath(root, filename)
    if ispath(filepath) error("$(filepath) already exists") end
    @info("Generating $filename at $filepath")
    mkpath(dirname(filepath))
    open(f,filepath,"w")
end

"""
$(SIGNATURES)

Contents of the default `make.jl` file.
"""
function make(pkgname; format = :html)
    fmtpkg = format === :markdown ? ", DocumenterMarkdown" :
             format === :pdf      ? ", DocumenterLaTeX" : ""
    fmtstr = format === :html ? "Documenter.HTML()" :
             format === :markdown  ? "Markdown()" :
             format === :pdf  ? "LaTeX()" : ""

    sitename = format !== :markdown ? "\n    sitename = \"$(pkgname)\"," : ""
    """
    using Documenter$(fmtpkg)
    using $(pkgname)

    makedocs($(sitename)
        format = $(fmtstr),
        modules = [$(pkgname)]
    )

    # Documenter can also automatically deploy documentation to gh-pages.
    # See "Hosting Documentation" and deploydocs() in the Documenter manual
    # for more information.
    #=deploydocs(
        repo = "<repository url>"
    )=#
    """
end

"""
$(SIGNATURES)

Contents of the default `.gitignore` file.
"""
function gitignore()
    """
    build/
    site/
    """
end

"""
$(SIGNATURES)

Contents of the default `Project.toml` file.
"""
function project(;format = :html)
    deps = Dict("Documenter" => "e30172f5-a6a5-5a46-863b-614d45cd2de4")
    if format === :markdown
        deps["DocumenterMarkdown"] = "997ab1e6-3595-5248-9280-8efb232c3433"
    elseif format === :pdf
        deps["DocumenterLaTeX"] = "cd674d7a-5f81-5cf3-af33-235ef1834b99"
    end
    io = IOBuffer()
    print(io, "[deps]\n")
    for dep in deps
        print(io, dep.first, " = \"", dep.second, "\"\n")
    end

    return String(take!(io))
end

mkdocs_default(name, value, default) = value == nothing ? "#$name$default" : "$name$value"

"""
$(SIGNATURES)

Contents of the default `mkdocs.yml` file.
"""
function mkdocs(pkgname;
        description = nothing,
        author = nothing,
        url = nothing
    )
    s = """
    # See the mkdocs user guide for more information on these settings.
    #   http://www.mkdocs.org/user-guide/configuration/

    site_name:        $(pkgname).jl
    $(mkdocs_default("repo_url:         ", url, "https://github.com/USER_NAME/PACKAGE_NAME.jl"))
    $(mkdocs_default("site_description: ", description, "Description..."))
    $(mkdocs_default("site_author:      ", author, "USER_NAME"))

    theme: readthedocs

    extra_css:
      - assets/Documenter.css

    extra_javascript:
      - https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS_HTML
      - assets/mathjaxhelper.js

    markdown_extensions:
      - extra
      - tables
      - fenced_code
      - mdx_math

    docs_dir: 'build'

    pages:
      - Home: index.md
    """
end

"""
$(SIGNATURES)

Contents of the default `src/index.md` file.
"""
function index(pkgname)
    """
    # $(pkgname).jl

    Documentation for $(pkgname).jl
    """
end

end

"""
The [`Themes`](@ref) module contains APIs to more easily compile the Documenter Sass themes
into CSS files.

To compile an Sass file into a Documenter theme, you can use the [`Themes.compile`](@ref)
function:

```julia-repl
julia> using DocumenterTools: Themes

julia> Themes.compile("mytheme.scss")
```

When working on the Documenter built-in themes, the [`Themes.themewatcher`](@ref) function
can be used to automatically update all the built-in themes when any of the Sass files are
modified. To enable it, just run

```julia-repl
julia> using DocumenterTools: Themes

julia> Themes.themewatcher()
```

Note that it will read and overwrite the Sass and CSS files of the Documenter of the
environment DocumenterTools is loaded in — make sure that you have Documenter added as a
development dependency to that environment.
"""
module Themes
using FileWatching
using Documenter.Writers: HTMLWriter
using Sass

"""
    compile(src[, dst])

Compile an input Sass/SCSS file `src` into a CSS file. The standard Documenter Sass/SCSS
files are available in the include path.

The optional `dst` argument can be used to specify the output file. Otherwise, the file
extension of the `src` file is simply replaced by `.css`.
"""
function compile(src, dst=nothing)
    isfile(src) || error("SCSS source file missing: $src")
    if dst === nothing
        s = (endswith(src, ".scss") || endswith(src, ".sass")) ? first(splitext(src)) : src
        dst = "$(s).css"
    end
    # Create the directory for destination file if it doesn't exist
    isdir(dirname(dst)) || mkpath(dirname(dst))
    Sass.compile_file(src, dst; include_path=HTMLWriter.ASSETS_SASS, output_style=Sass.compressed)
end

"""
    compile_native_theme(name; dst=nothing)

Compiles a native Documenter theme and places it into Documenter's assets directory.

Optionally, the `dst` keyword argument can be used to specify the output file.
"""
function compile_native_theme(name; dst = nothing)
    name in HTMLWriter.THEMES || error("Bad theme name. Valid themes: $(HTMLWriter.THEMES)")
    src = joinpath(HTMLWriter.ASSETS_SASS, "$(name).scss")
    dst = (dst === nothing) ? joinpath(HTMLWriter.ASSETS_THEMES, "$(name).css") : dst
    compile(src, dst)
    return dst
end

function compile_native_themes()
    for theme in HTMLWriter.THEMES
        compile_native_theme(theme)
    end
end


# themewatcher() watches the Documenter theme source SCSS/Sass files and recompiles
# the native themes if there are any changes
const compiler_channel = Channel{Any}(1024)
const tasks = Vector{Tuple{Task,Channel{Any}}}()

"""
    themewatcher()

Starts an asynchronous background task that checks for changes in the Documenter Sass files
and recompiles all native themes whenever changes are detected.
"""
themewatcher(; kwargs...) = isempty(tasks) ?
    themewatcher_start(; kwargs...) : themewatcher_stop(; kwargs...)

function themewatcher_start(; dst=nothing, kwargs...)
    # Start the compiler task
    t = @async compiler(compiler_channel; dst=dst)
    push!(tasks, (t, compiler_channel))
    # Start watchers on all theme subdirectories
    for directory in all_subdirectories(HTMLWriter.ASSETS_SASS)
        start_watcher(directory)
    end
end

function themewatcher_stop(; kwargs...)
    # Send stop messages to all tasks
    for (_, c) in tasks
        put!(c, false)
    end
    # Wait for all of the tasks to finish
    for (t, _) in tasks
        try
            wait(t)
        catch e
            @warn "Task $t failed with exception" e
        end
    end
    # clear out the task list
    empty!(tasks)
    # clear out the compiler_channel channel
    while isready(compiler_channel)
        take!(compiler_channel)
    end
end

function all_subdirectories(d)
    vcat(d, mapreduce(vcat, walkdir(d)) do (root, dirs, _)
        [joinpath(root, d) for d in dirs]
    end)
end

function start_watcher(directory)
    channel = Channel{Any}(32)
    task = @async watcher(channel, directory, compiler_channel)
    push!(tasks, (task, channel))
end

function watcher(channel, directory, compiler_channel)
    @info "Starting watcher for: $(directory)"
    while true
        (f, reason) = watch_folder(directory, 2)
        if reason.changed
            @info "Change detected: $(f)" directory
            if endswith(f, ".scss") || endswith(f, ".sass")
                put!(compiler_channel, true)
            else
                @info "Ignoring $(f) -- not Sass"
            end
        end
        if isready(channel)
            @info "Received message, exiting watcher." directory take!(channel)
            return
        end
    end
end

function compiler(compiler_channel; dst=nothing)
    @info "Starting Sass compiler task." dst
    while true
        sleep(1)
        if isready(compiler_channel)
            @info "Received messages to compiler."
            while isready(compiler_channel)
                msg = take!(compiler_channel)
                if !msg
                    @info "Exiting compiler."
                    return
                end
            end
            for theme in HTMLWriter.THEMES
                @info "Compiling: $(theme)"
                _dst = nothing
                if dst !== nothing
                    _dst = joinpath(dst, "$(theme).css")
                end
                try
                    compile_native_theme(theme; dst=_dst)
                catch e
                    @warn "Compilation of $(theme) failed" e
                end
            end
        end
    end
end

end

module GenerateTests

using DocumenterTools
using Test
using Pkg
using Example

@testset "Generate" begin
    function check_docdir(path; format)
        @test isdir(path)
        @test isfile(joinpath(path, "mkdocs.yml")) == (format === :markdown)
        @test isfile(joinpath(path, ".gitignore"))
        @test isfile(joinpath(path, "Project.toml"))
        @test isfile(joinpath(path, "make.jl"))
        @test isdir(joinpath(path, "src"))
        @test isfile(joinpath(path, "src", "index.md"))
    end
    mktempdir() do tmp; cd(tmp) do
        # generate from module argument
        Pkg.generate("Pkg1")
        Pkg.develop(PackageSpec(path = "Pkg1"))
        mod = Module()
        @eval mod using Pkg1, DocumenterTools
        @test_logs (:info, r"deploying documentation to") (:info, r"Generating \.gitignore") (:info, r"Generating make\.jl") (:info, r"Generating Project\.toml") (:info, r"Generating src/index\.md") @eval mod DocumenterTools.generate(Pkg1; format = :html)
        check_docdir(joinpath("Pkg1", "docs"); format = :html)
        @test_throws ArgumentError @eval mod DocumenterTools.generate(Pkg1)
        Pkg.rm(PackageSpec("Pkg1"))

        # generate from path
        Pkg.generate("Pkg2")
        @test_logs (:info, r"name of package automatically determined to be") (:info, r"deploying documentation to") (:info, r"Generating \.gitignore") (:info, r"Generating make\.jl") (:info, r"Generating mkdocs\.yml") (:info, r"Generating Project\.toml") (:info, r"Generating src/index\.md") DocumenterTools.generate(joinpath("Pkg2", "docs"); format = :markdown)
        check_docdir(joinpath("Pkg2", "docs"); format = :markdown)
        @test_throws ArgumentError DocumenterTools.generate(joinpath("Pkg2", "docs"))

        # generate where name can't be determined
        mkdir("Pkg3")
        @test_throws ArgumentError DocumenterTools.generate(joinpath("Pkg3", "docs"))
        mkdir(joinpath("Pkg3", "src"))
        @test_throws ArgumentError DocumenterTools.generate(joinpath("Pkg3", "docs"))
        write(joinpath("Pkg3", "src", "Pkg3.jl"), "module Pkg3\nend\n")
        write(joinpath("Pkg3", "src", "Pkg4.jl"), "module Pkg4\nend\n")
        @test_throws ArgumentError DocumenterTools.generate(joinpath("Pkg3", "docs"))
        @test_logs (:info, r"deploying documentation to") (:info, r"Generating \.gitignore") (:info, r"Generating make\.jl") (:info, r"Generating Project\.toml") (:info, r"Generating src/index\.md") DocumenterTools.generate(joinpath("Pkg3", "docs"); name = "Pkg3", format = :pdf)
        check_docdir(joinpath("Pkg3", "docs"), format = :pdf)

        # throw for a package that is installed and not deved
        @test_throws ArgumentError DocumenterTools.generate(Example)

        # throw for a submodule
        @test_throws ArgumentError DocumenterTools.generate(Broadcast)
    end; end
end

end

mktempdir() do TMP
    cp(joinpath(@__DIR__, "fixtures"), joinpath(TMP, "fixtures"))
    chmod(joinpath(TMP, "fixtures"), 0o777, recursive=true)

    index_changed = joinpath(TMP, "fixtures", "index_changed.html")
    cp(joinpath(TMP, "fixtures", "index.html"), index_changed, force=true)
    OutdatedWarning.add_old_docs_notice(index_changed)
    output = read(index_changed, String)

    @test occursin("data-outdated-warner", output)
    # The following is sensitive to how Gumbo.jl writes HTML, but let's hope that doesn't change often:
    @test replace(output, "\r\n" => "\n") == replace(read(joinpath(@__DIR__, "fixtures", "index_after.html"), String), "\r\n" => "\n")


    transient_path = joinpath(TMP, "fixtures", "transient")
    cp(joinpath(TMP, "fixtures", "pre"), transient_path, force=true)
    @test_logs (:warn, r"Adding an `OutdatedWarning`") OutdatedWarning.generate(transient_path)

    for (root, _, files) in walkdir(transient_path)
        for file in files
            content = read(joinpath(root, file), String)
            expected = read(joinpath(replace(root, "transient" => "post"), file), String)
            @test replace(content, "\r\n" => "\n") == replace(expected, "\r\n" => "\n")
        end
    end

    rm(joinpath(TMP, "fixtures"), recursive=true)
end
